Index: src/Parser/PcpParser.cpp
===================================================================
--- src/Parser/PcpParser.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Parser/PcpParser.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * PcpParser.cpp
@@ -6,7 +13,15 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
 #include <iostream>
 #include <iomanip>
 
+//#include "Actions/FragmentationAction/SubgraphDissectionAction.hpp"
 #include "atom.hpp"
 #include "config.hpp"
@@ -14,84 +29,112 @@
 #include "element.hpp"
 #include "Helpers/Assert.hpp"
-#include "log.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "LinearAlgebra/Matrix.hpp"
 #include "molecule.hpp"
 #include "PcpParser.hpp"
 #include "periodentafel.hpp"
 #include "ThermoStatContainer.hpp"
-#include "verbose.hpp"
 #include "World.hpp"
-#include "Matrix.hpp"
 #include "Box.hpp"
+
+
+PcpParser::StructParallelization::StructParallelization() :
+  ProcPEGamma(8),
+  ProcPEPsi(1)
+{}
+
+PcpParser::StructParallelization::~StructParallelization()
+{}
+
+PcpParser::StructPaths::StructPaths() :
+  databasepath(NULL),
+  configname(NULL),
+  mainname(NULL),
+  defaultpath(NULL),
+  pseudopotpath(NULL)
+{}
+
+PcpParser::StructPaths::~StructPaths()
+{}
+
+PcpParser::StructSwitches::StructSwitches() :
+  DoConstrainedMD(0),
+  DoOutVis(0),
+  DoOutMes(1),
+  DoOutNICS(0),
+  DoOutOrbitals(0),
+  DoOutCurrent(0),
+  DoFullCurrent(0),
+  DoPerturbation(0),
+  DoWannier(0)
+{}
+
+PcpParser::StructSwitches::~StructSwitches()
+{}
+
+PcpParser::StructLocalizedOrbitals::StructLocalizedOrbitals() :
+  CommonWannier(0),
+  SawtoothStart(0.01),
+  VectorPlane(0),
+  VectorCut(0),
+  UseAddGramSch(1),
+  Seed(1),
+  EpsWannier(1e-7)
+{}
+
+PcpParser::StructLocalizedOrbitals::~StructLocalizedOrbitals()
+{}
+
+PcpParser::StructStepCounts::StructStepCounts() :
+  MaxMinStopStep(1),
+  InitMaxMinStopStep(1),
+  OutVisStep(10),
+  OutSrcStep(5),
+  MaxPsiStep(0),
+  MaxOuterStep(0),
+  MaxMinStep(100),
+  RelEpsTotalEnergy(1e-07),
+  RelEpsKineticEnergy(1e-05),
+  MaxMinGapStopStep(0),
+  MaxInitMinStep(100),
+  InitRelEpsTotalEnergy(1e-05),
+  InitRelEpsKineticEnergy(0.0001),
+  InitMaxMinGapStopStep(0)
+{}
+
+PcpParser::StructStepCounts::~StructStepCounts()
+{}
+
+PcpParser::StructPlaneWaveSpecifics::StructPlaneWaveSpecifics() :
+  PsiType(0),
+  MaxPsiDouble(0),
+  PsiMaxNoUp(0),
+  PsiMaxNoDown(0),
+  ECut(128),
+  MaxLevel(5),
+  RiemannTensor(0),
+  LevRFactor(0),
+  RiemannLevel(0),
+  Lev0Factor(2),
+  RTActualUse(0),
+  AddPsis(0),
+  RCut(20)
+{}
+
+PcpParser::StructPlaneWaveSpecifics::~StructPlaneWaveSpecifics()
+{}
 
 /** Constructor of PcpParser.
  *
  */
-PcpParser::PcpParser()
-{
-  Parallelization.ProcPEGamma = 8;
-  Parallelization.ProcPEPsi = 1;
-
-  Paths.databasepath = NULL;
-  Paths.configname = NULL;
-  Paths.mainname = NULL;
-  Paths.defaultpath = NULL;
-  Paths.pseudopotpath = NULL;
-
-  Switches.DoConstrainedMD = 0;
-  Switches.DoOutVis = 0;
-  Switches.DoOutMes = 1;
-  Switches.DoOutNICS = 0;
-  Switches.DoOutOrbitals = 0;
-  Switches.DoOutCurrent = 0;
-  Switches.DoFullCurrent = 0;
-  Switches.DoPerturbation = 0;
-  Switches.DoWannier = 0;
-
-  LocalizedOrbitals.CommonWannier = 0;
-  LocalizedOrbitals.SawtoothStart = 0.01;
-  LocalizedOrbitals.VectorPlane = 0;
-  LocalizedOrbitals.VectorCut = 0;
-  LocalizedOrbitals.UseAddGramSch = 1;
-  LocalizedOrbitals.Seed = 1;
-  LocalizedOrbitals.EpsWannier = 1e-7;
-
-  StepCounts.MaxMinStopStep = 1;
-  StepCounts.InitMaxMinStopStep = 1;
-  StepCounts.OutVisStep = 10;
-  StepCounts.OutSrcStep = 5;
-  StepCounts.MaxPsiStep = 0;
-  StepCounts.MaxOuterStep = 0;
-  StepCounts.MaxMinStep = 100;
-  StepCounts.RelEpsTotalEnergy = 1e-07;
-  StepCounts.RelEpsKineticEnergy = 1e-05;
-  StepCounts.MaxMinGapStopStep = 0;
-  StepCounts.MaxInitMinStep = 100;
-  StepCounts.InitRelEpsTotalEnergy = 1e-05;
-  StepCounts.InitRelEpsKineticEnergy = 0.0001;
-  StepCounts.InitMaxMinGapStopStep = 0;
-
-  PlaneWaveSpecifics.PsiType = 0;
-  PlaneWaveSpecifics.MaxPsiDouble = 0;
-  PlaneWaveSpecifics.PsiMaxNoUp = 0;
-  PlaneWaveSpecifics.PsiMaxNoDown = 0;
-  PlaneWaveSpecifics.ECut = 128;
-  PlaneWaveSpecifics.MaxLevel = 5;
-  PlaneWaveSpecifics.RiemannTensor = 0;
-  PlaneWaveSpecifics.LevRFactor = 0;
-  PlaneWaveSpecifics.RiemannLevel = 0;
-  PlaneWaveSpecifics.Lev0Factor = 2;
-  PlaneWaveSpecifics.RTActualUse = 0;
-  PlaneWaveSpecifics.AddPsis = 0;
-  PlaneWaveSpecifics.RCut = 20;
-  PlaneWaveSpecifics.PsiType = 0;
-
-  FastParsing = false;
-
-  Deltat = 0.01;
-  IsAngstroem = 1;
-  RelativeCoord = 0;
-  StructOpt = 0;
-  MaxTypes = 0;
-}
+PcpParser::PcpParser() :
+  FastParsing(false),
+  Deltat(0.01),
+  IsAngstroem(1),
+  RelativeCoord(0),
+  StructOpt(0),
+  MaxTypes(0)
+{}
 
 /** Destructor of PcpParser.
@@ -321,5 +364,5 @@
   // 4. dissect the molecule into connected subgraphs
   // don't do this here ...
-  //MolList->DissectMoleculeIntoConnectedSubgraphs(mol,this);
+  //FragmentationSubgraphDissection();
   //delete(mol);
 
@@ -332,4 +375,6 @@
 void PcpParser::save(std::ostream* file)
 {
+  DoLog(0) && (Log() << Verbose(0) << "Saving changes to pcp." << std::endl);
+
   const Matrix &domain = World::getInstance().getDomain().getM();
   class ThermoStatContainer *Thermostats = World::getInstance().getThermostats();
@@ -364,26 +409,6 @@
     *file << "DoConstrainedMD\t" << Switches.DoConstrainedMD << "\t# Do perform a constrained (>0, relating to current MD step) instead of unconstrained (0) MD" << endl;
     ASSERT(Thermostats != NULL, "PcpParser::save() - Thermostats not initialized!");
-    ASSERT(Thermostats->ThermostatNames != NULL, "PcpParser::save() - Thermostats not initialized!");
-    *file << "Thermostat\t" << Thermostats->ThermostatNames[Thermostats->Thermostat] << "\t";
-    switch(Thermostats->Thermostat) {
-      default:
-      case None:
-        break;
-      case Woodcock:
-        *file << Thermostats->ScaleTempStep;
-        break;
-      case Gaussian:
-        *file << Thermostats->ScaleTempStep;
-        break;
-      case Langevin:
-        *file << Thermostats->TempFrequency << "\t" << Thermostats->alpha;
-        break;
-      case Berendsen:
-        *file << Thermostats->TempFrequency;
-        break;
-      case NoseHoover:
-        *file << Thermostats->HooverMass;
-        break;
-    };
+    *file << "Thermostat\t" << Thermostats->activeThermostat->name() << "\t";
+    *file << Thermostats->activeThermostat->writeParams();
     *file << "\t# Which Thermostat and its parameters to use in MD case." << endl;
     *file << "CommonWannier\t" << LocalizedOrbitals.CommonWannier << "\t# Put virtual centers at indivual orbits, all common, merged by variance, to grid point, to cell center" << endl;
@@ -460,5 +485,5 @@
   PlaneWaveSpecifics.MaxPsiDouble = PlaneWaveSpecifics.PsiMaxNoDown = PlaneWaveSpecifics.PsiMaxNoUp = PlaneWaveSpecifics.PsiType = 0;
   for (vector<atom *>::iterator runner = allatoms.begin(); runner != allatoms.end(); ++runner) {
-    PlaneWaveSpecifics.MaxPsiDouble += (*runner)->type->NoValenceOrbitals;
+    PlaneWaveSpecifics.MaxPsiDouble += (*runner)->getType()->getNoValenceOrbitals();
   }
   cout << PlaneWaveSpecifics.MaxPsiDouble << endl;
@@ -495,5 +520,5 @@
   // insert all found elements into the map
   for (vector<atom *>::iterator AtomRunner = allatoms.begin();AtomRunner != allatoms.end();++AtomRunner) {
-    Inserter = PresentElements.insert(pair<int, int>((*AtomRunner)->type->Z, 1));
+    Inserter = PresentElements.insert(pair<int, int>((*AtomRunner)->getType()->getAtomicNumber(), 1));
     if (!Inserter.second) // increase if present
       Inserter.first->second += 1;
@@ -510,5 +535,5 @@
     const element * const elemental = World::getInstance().getPeriode()->FindElement(iter->first);
     ZtoIndexMap.insert( pair<int,int> (iter->first, counter) );
-    *file << "Ion_Type" << counter++ << "\t" << iter->second << "\t" << elemental->Z << "\t1.0\t3\t3\t" << fixed << setprecision(11) << showpoint << elemental->mass << "\t" << elemental->name << "\t" << elemental->symbol <<endl;
+    *file << "Ion_Type" << counter++ << "\t" << iter->second << "\t" << elemental->getAtomicNumber() << "\t1.0\t3\t3\t" << fixed << setprecision(11) << showpoint << elemental->getMass() << "\t" << elemental->getName() << "\t" << elemental->getSymbol() <<endl;
   }
 }
@@ -526,13 +551,13 @@
   int nr = 0;
   for (vector<atom *>::iterator AtomRunner = allatoms.begin();AtomRunner != allatoms.end();++AtomRunner) {
-    Inserter = ZtoCountMap.insert( pair<int, int>((*AtomRunner)->type->Z, 1) );
+    Inserter = ZtoCountMap.insert( pair<int, int>((*AtomRunner)->getType()->getAtomicNumber(), 1) );
     if (!Inserter.second)
       Inserter.first->second += 1;
-    const int Z = (*AtomRunner)->type->Z;
+    const int Z = (*AtomRunner)->getType()->getAtomicNumber();
     *file << "Ion_Type" << ZtoIndexMap[Z] << "_" << ZtoCountMap[Z] << "\t"  << fixed << setprecision(9) << showpoint;
-    *file << (*AtomRunner)->x[0] << "\t" << (*AtomRunner)->x[1] << "\t" << (*AtomRunner)->x[2];
+    *file << (*AtomRunner)->at(0) << "\t" << (*AtomRunner)->at(1) << "\t" << (*AtomRunner)->at(2);
     *file << "\t" << (*AtomRunner)->FixedIon;
-    if ((*AtomRunner)->v.Norm() > MYEPSILON)
-      *file << "\t" << scientific << setprecision(6) << (*AtomRunner)->v[0] << "\t" << (*AtomRunner)->v[1] << "\t" << (*AtomRunner)->v[2] << "\t";
+    if ((*AtomRunner)->AtomicVelocity.Norm() > MYEPSILON)
+      *file << "\t" << scientific << setprecision(6) << (*AtomRunner)->AtomicVelocity[0] << "\t" << (*AtomRunner)->AtomicVelocity[1] << "\t" << (*AtomRunner)->AtomicVelocity[2] << "\t";
     *file << " # molecule nr " << nr++ << endl;
   }
@@ -550,65 +575,9 @@
   // read desired Thermostat from file along with needed additional parameters
   if (ParseForParameter(verbose,fb,"Thermostat", 0, 1, 1, string_type, thermo, 1, optional)) {
-    if (strcmp(thermo, Thermostats->ThermostatNames[0]) == 0) { // None
-      if (Thermostats->ThermostatImplemented[0] == 1) {
-        Thermostats->Thermostat = None;
-      } else {
-        DoLog(1) && (Log() << Verbose(1) << "Warning: " << Thermostats->ThermostatNames[0] << " thermostat not implemented, falling back to None." << endl);
-        Thermostats->Thermostat = None;
-      }
-    } else if (strcmp(thermo, Thermostats->ThermostatNames[1]) == 0) { // Woodcock
-      if (Thermostats->ThermostatImplemented[1] == 1) {
-        Thermostats->Thermostat = Woodcock;
-        ParseForParameter(verbose,fb,"Thermostat", 0, 2, 1, int_type, &Thermostats->ScaleTempStep, 1, critical); // read scaling frequency
-      } else {
-        DoLog(1) && (Log() << Verbose(1) << "Warning: " << Thermostats->ThermostatNames[0] << " thermostat not implemented, falling back to None." << endl);
-        Thermostats->Thermostat = None;
-      }
-    } else if (strcmp(thermo, Thermostats->ThermostatNames[2]) == 0) { // Gaussian
-      if (Thermostats->ThermostatImplemented[2] == 1) {
-        Thermostats->Thermostat = Gaussian;
-        ParseForParameter(verbose,fb,"Thermostat", 0, 2, 1, int_type, &Thermostats->ScaleTempStep, 1, critical); // read collision rate
-      } else {
-        DoLog(1) && (Log() << Verbose(1) << "Warning: " << Thermostats->ThermostatNames[0] << " thermostat not implemented, falling back to None." << endl);
-        Thermostats->Thermostat = None;
-      }
-    } else if (strcmp(thermo, Thermostats->ThermostatNames[3]) == 0) { // Langevin
-      if (Thermostats->ThermostatImplemented[3] == 1) {
-        Thermostats->Thermostat = Langevin;
-        ParseForParameter(verbose,fb,"Thermostat", 0, 2, 1, double_type, &Thermostats->TempFrequency, 1, critical); // read gamma
-        if (ParseForParameter(verbose,fb,"Thermostat", 0, 3, 1, double_type, &Thermostats->alpha, 1, optional)) {
-          DoLog(2) && (Log() << Verbose(2) << "Extended Stochastic Thermostat detected with interpolation coefficient " << Thermostats->alpha << "." << endl);
-        } else {
-          Thermostats->alpha = 1.;
-        }
-      } else {
-        DoLog(1) && (Log() << Verbose(1) << "Warning: " << Thermostats->ThermostatNames[0] << " thermostat not implemented, falling back to None." << endl);
-        Thermostats->Thermostat = None;
-      }
-    } else if (strcmp(thermo, Thermostats->ThermostatNames[4]) == 0) { // Berendsen
-      if (Thermostats->ThermostatImplemented[4] == 1) {
-        Thermostats->Thermostat = Berendsen;
-        ParseForParameter(verbose,fb,"Thermostat", 0, 2, 1, double_type, &Thermostats->TempFrequency, 1, critical); // read \tau_T
-      } else {
-        DoLog(1) && (Log() << Verbose(1) << "Warning: " << Thermostats->ThermostatNames[0] << " thermostat not implemented, falling back to None." << endl);
-        Thermostats->Thermostat = None;
-      }
-    } else if (strcmp(thermo, Thermostats->ThermostatNames[5]) == 0) { // Nose-Hoover
-      if (Thermostats->ThermostatImplemented[5] == 1) {
-        Thermostats->Thermostat = NoseHoover;
-        ParseForParameter(verbose,fb,"Thermostat", 0, 2, 1, double_type, &Thermostats->HooverMass, 1, critical); // read Hoovermass
-        Thermostats->alpha = 0.;
-      } else {
-        DoLog(1) && (Log() << Verbose(1) << "Warning: " << Thermostats->ThermostatNames[0] << " thermostat not implemented, falling back to None." << endl);
-        Thermostats->Thermostat = None;
-      }
-    } else {
-      DoLog(1) && (Log() << Verbose(1) << " Warning: thermostat name was not understood!" << endl);
-      Thermostats->Thermostat = None;
-    }
+    Thermostats->makeActive(thermo,fb);
   } else {
     if ((Thermostats->TargetTemp != 0))
       DoLog(2) && (Log() << Verbose(2) <<  "No thermostat chosen despite finite temperature MD, falling back to None." << endl);
-    Thermostats->Thermostat = None;
+    Thermostats->chooseNone();
   }
   delete[](thermo);
Index: src/Parser/PcpParser.hpp
===================================================================
--- src/Parser/PcpParser.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Parser/PcpParser.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -31,5 +31,9 @@
   void CalculateOrbitals(vector<atom *> &allatoms);
 
-  struct StructParallelization {
+  class StructParallelization {
+  public:
+    StructParallelization();
+    ~StructParallelization();
+
     int ProcPEGamma;
     int ProcPEPsi;
@@ -39,5 +43,9 @@
    * Contains all the paths and names
    */
-  struct StructPaths {
+  class StructPaths {
+  public:
+    StructPaths();
+    ~StructPaths();
+
     char *databasepath;
     char *configname;
@@ -50,5 +58,9 @@
    * Contains all Do/Don't switches
    */
-  struct StructSwitches {
+  class StructSwitches {
+  public:
+    StructSwitches();
+    ~StructSwitches();
+
     int DoConstrainedMD;
     int DoOutVis;
@@ -65,5 +77,9 @@
    * Contains parameters regarding localization of orbitals or magnetic perturbation
    */
-  struct StructLocalizedOrbitals {
+  class StructLocalizedOrbitals {
+  public:
+    StructLocalizedOrbitals();
+    ~StructLocalizedOrbitals();
+
     int CommonWannier;
     double SawtoothStart;
@@ -78,5 +94,9 @@
    * Contains all step count and other epsilon threshold parameters
    */
-  struct StructStepCounts {
+  class StructStepCounts {
+  public:
+    StructStepCounts();
+    ~StructStepCounts();
+
     int MaxMinStopStep;
     int InitMaxMinStopStep;
@@ -101,5 +121,9 @@
    * Contains all parameters specific to the plane wave basis set
    */
-  struct StructPlaneWaveSpecifics {
+  class StructPlaneWaveSpecifics {
+  public:
+    StructPlaneWaveSpecifics();
+    ~StructPlaneWaveSpecifics();
+
     int PsiType;
     int MaxPsiDouble;
Index: src/Parser/PdbParser.cpp
===================================================================
--- src/Parser/PdbParser.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Parser/PdbParser.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,433 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * PdbParser.cpp
+ *
+ *  Created on: Aug 17, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "Helpers/Assert.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "PdbParser.hpp"
+#include "World.hpp"
+#include "atom.hpp"
+#include "bond.hpp"
+#include "element.hpp"
+#include "molecule.hpp"
+#include "periodentafel.hpp"
+#include "Descriptors/AtomIdDescriptor.hpp"
+
+#include <map>
+#include <vector>
+
+#include <iostream>
+#include <iomanip>
+
+using namespace std;
+
+/**
+ * Constructor.
+ */
+PdbParser::PdbParser() {
+  knownKeys[" "] = PdbKey::noKey; // with this we can detect invalid keys
+  knownKeys["x"] = PdbKey::x;
+  knownKeys["Id"] = PdbKey::Id;
+  knownKeys["Type"] = PdbKey::Type;
+  knownKeys["extType"] = PdbKey::extType;
+  knownKeys["name"] = PdbKey::name;
+  knownKeys["resName"] = PdbKey::resName;
+  knownKeys["chainID"] = PdbKey::chainID;
+  knownKeys["resSeq"] = PdbKey::resSeq;
+  knownKeys["occupancy"] = PdbKey::occupancy;
+  knownKeys["tempFactor"] = PdbKey::tempFactor;
+  knownKeys["segID"] = PdbKey::segID;
+  knownKeys["charge"] = PdbKey::charge;
+}
+
+/**
+ * Destructor.
+ */
+PdbParser::~PdbParser() {
+  additionalAtomData.clear();
+  atomIdMap.clear();
+  knownKeys.clear();
+}
+
+/**
+ * Loads atoms from a tremolo-formatted file.
+ *
+ * \param tremolo file
+ */
+void PdbParser::load(istream* file) {
+//  string line;
+//  string::size_type location;
+//
+//  usedFields.clear();
+//  while (file->good()) {
+//    std::getline(*file, line, '\n');
+//    if (usedFields.empty()) {
+//      location = line.find("ATOMDATA", 0);
+//      if (location != string::npos) {
+//       parseAtomDataKeysLine(line, location + 8);
+//      }
+//    }
+//    if (line.length() > 0 && line.at(0) != '#') {
+//      readAtomDataLine(line);
+//    }
+//  }
+//
+//  processNeighborInformation();
+//  adaptImprData();
+//  adaptTorsion();
+}
+
+/**
+ * Saves the World's current state into as a tremolo file.
+ *
+ * \param file where to save the state
+ */
+void PdbParser::save(ostream* file) {
+  DoLog(0) && (Log() << Verbose(0) << "Saving changes to pdb." << std::endl);
+
+  {
+    // add initial remark
+    *file << "REMARK created by molecuilder on ";
+    time_t now = time((time_t *)NULL);   // Get the system time and put it into 'now' as 'calender time'
+    // ctime ends in \n\0, we have to cut away the newline
+    std::string time(ctime(&now));
+    size_t pos = time.find('\n');
+    if (pos != 0)
+      *file << time.substr(0,pos);
+    else
+      *file << time;
+    *file << endl;
+  }
+
+  {
+    vector<atom *> AtomList = World::getInstance().getAllAtoms();
+
+    std::vector<int> elementNo(MAX_ELEMENTS,1);
+    char name[MAXSTRINGSIZE];
+
+    // write ATOMs
+    int AtomNo = 1; // serial number starts at 1 in pdb
+    int MolNo = 1;  // residue number starts at 1 in pdb
+    for (vector<atom *>::iterator atomIt = AtomList.begin(); atomIt != AtomList.end(); atomIt++) {
+      const size_t  Z = (*atomIt)->getType()->getAtomicNumber();
+      sprintf(name, "%2s%02d",(*atomIt)->getType()->getSymbol().c_str(), elementNo[Z]);
+      elementNo[Z] = (elementNo[Z]+1) % 100;   // confine to two digits
+      const molecule *mol = (*atomIt)->getMolecule();
+      if (mol == NULL) {  // for homeless atoms, MolNo = 0 is reserved
+        MolNo = 0;
+      } else {
+        MolNo = mol->getId();
+      }
+      saveLine(file, *atomIt, name, AtomNo, MolNo);
+      setAtomId((*atomIt)->getId(), AtomNo);
+      AtomNo++;
+    }
+
+    // write CONECTs
+    for (vector<atom *>::iterator atomIt = AtomList.begin(); atomIt != AtomList.end(); atomIt++) {
+      writeNeighbors(file, 4, *atomIt);
+    }
+  }
+
+  // END
+  *file << "END" << endl;
+}
+
+/**
+ * Writes one line of tremolo-formatted data to the provided stream.
+ *
+ * \param stream where to write the line to
+ * \param *currentAtom the atom of which information should be written
+ * \param *name name of atom, i.e. H01
+ * \param AtomNo serial number of atom
+ * \param ResidueNo number of residue
+ */
+void PdbParser::saveLine(ostream* file, const atom* currentAtom, const char *name, const int AtomNo, const int ResidueNo) {
+  *file << "ATOM ";
+  *file << setw(6) << AtomNo; /* atom serial number */
+  *file << setw(1) << " ";
+  *file << setfill(' ') << left << setw(4) << name << right;  /* atom name */
+  *file << setw(1) << " ";
+  *file << setfill(' ') << setw(3) << ((currentAtom->getMolecule() != NULL) ? currentAtom->getMolecule()->getName().substr(0,3) : "-");  /* residue name */
+  *file << setw(1) << " ";
+  *file << setfill(' ') << setw(1) << (char)('a'+(unsigned char)(AtomNo % 26)); /* letter for chain */
+  *file << setw(4) << ResidueNo; /* residue sequence number */
+  *file << setw(4) << "    ";
+  for (int i=0;i<NDIM;i++) {
+    *file << setw(8) << setprecision(3) << showpoint << currentAtom->at(i); /* positional coordinate in Angstroem */
+  }
+  *file << setw(6) << setprecision(2) << showpoint << (double)currentAtom->getType()->getValence(); /* occupancy */
+  *file << setw(6) << setprecision(2) << showpoint << (double)currentAtom->getType()->getNoValenceOrbitals(); /* temperature factor */
+  *file << noshowpoint;
+  *file << setw(6) << "      ";
+  *file << setw(4) << "0";
+  *file << setfill(' ') << setw(2) << currentAtom->getType()->getSymbol();
+  *file << setw(2) << "0";
+
+  *file << endl;
+}
+
+/**
+ * Writes the neighbor information of one atom to the provided stream.
+ *
+ * \param *file  where to write neighbor information to
+ * \param MaxnumberOfNeighbors of neighbors
+ * \param *currentAtom to the atom of which to take the neighbor information
+ */
+void PdbParser::writeNeighbors(ostream* file, int MaxnumberOfNeighbors, atom* currentAtom) {
+  if (!currentAtom->ListOfBonds.empty()) {
+    *file << "CONECT";
+    *file << setw(5) << getAtomId(currentAtom->getId());
+    int MaxNo = 0;
+    for(BondList::iterator currentBond = currentAtom->ListOfBonds.begin(); currentBond != currentAtom->ListOfBonds.end(); ++currentBond) {
+      if (MaxNo < MaxnumberOfNeighbors) {
+        *file << setw(5) << getAtomId((*currentBond)->GetOtherAtom(currentAtom)->getId());
+      }
+      MaxNo++;
+    }
+    *file << endl;
+  }
+}
+
+
+/** Retrieves a value from PdbParser::atomIdMap.
+ * \param atomid key
+ * \return value
+ */
+int PdbParser::getAtomId(int atomid) const
+{
+  ASSERT(atomIdMap.find(atomid) != atomIdMap.end(), "PdbParser::getAtomId: atomid not present in Map.");
+  return (atomIdMap.find(atomid)->second);
+}
+
+/** Sets an entry in PdbParser::atomIdMap.
+ * \param localatomid key
+ * \param atomid value
+ * \return true - key not present, false - value present
+ */
+void PdbParser::setAtomId(int localatomid, int atomid)
+{
+  pair<std::map<int,int>::iterator, bool > inserter;
+  inserter = atomIdMap.insert( pair<int, int>(localatomid, atomid) );
+  ASSERT(inserter.second, "PdbParser::setAtomId: atomId already present in Map.");
+}
+
+/**
+ * Reads one data line of a tremolo file and interprets it according to the keys
+ * obtained from the ATOMDATA line.
+ *
+ * \param line to parse as an atom
+ */
+void PdbParser::readAtomDataLine(string line) {
+//  vector<string>::iterator it;
+//  stringstream lineStream;
+//  atom* newAtom = World::getInstance().createAtom();
+//  PdbAtomInfoContainer *atomInfo = NULL;
+//  additionalAtomData[newAtom->getId()] = *(new PdbAtomInfoContainer);
+//  atomInfo = &additionalAtomData[newAtom->getId()];
+//  PdbKey::atomDataKey currentField;
+//  string word;
+//  int oldId;
+//  double tmp;
+//
+//  lineStream << line;
+//  for (it = usedFields.begin(); it < usedFields.end(); it++) {
+//    currentField = knownKeys[it->substr(0, it->find("="))];
+//    switch (currentField) {
+//      case PdbKey::x :
+//        // for the moment, assume there are always three dimensions
+//        for (int i=0;i<NDIM;i++) {
+//          lineStream >> tmp;
+//          newAtom->set(i, tmp);
+//        }
+//        break;
+//      case PdbKey::u :
+//        // for the moment, assume there are always three dimensions
+//        lineStream >> newAtom->AtomicVelocity[0];
+//        lineStream >> newAtom->AtomicVelocity[1];
+//        lineStream >> newAtom->AtomicVelocity[2];
+//        break;
+//      case PdbKey::Type :
+//        char type[3];
+//        lineStream >> type;
+//        newAtom->setType(World::getInstance().getPeriode()->FindElement(type));
+//        ASSERT(newAtom->getType(), "Type was not set for this atom");
+//        break;
+//      case PdbKey::Id :
+//        lineStream >> oldId;
+//        atomIdMap[oldId] = newAtom->getId();
+//        break;
+//      case PdbKey::neighbors :
+//        readNeighbors(&lineStream,
+//            atoi(it->substr(it->find("=") + 1, 1).c_str()), newAtom->getId());
+//        break;
+//      default :
+//        lineStream >> word;
+//        atomInfo->set(currentField, word);
+//        break;
+//    }
+//  }
+}
+
+/**
+ * Reads neighbor information for one atom from the input.
+ *
+ * \param stream where to read the information from
+ * \param number of neighbors to read
+ * \param world id of the atom the information belongs to
+ */
+void PdbParser::readNeighbors(stringstream* line, int numberOfNeighbors, int atomId) {
+//  int neighborId = 0;
+//  for (int i = 0; i < numberOfNeighbors; i++) {
+//    *line >> neighborId;
+//    // 0 is used to fill empty neighbor positions in the tremolo file.
+//    if (neighborId > 0) {
+//      additionalAtomData[atomId].neighbors.push_back(neighborId);
+//    }
+//  }
+}
+
+/**
+ * Adds the collected neighbor information to the atoms in the world. The atoms
+ * are found by their current ID and mapped to the corresponding atoms with the
+ * Id found in the parsed file.
+ */
+void PdbParser::processNeighborInformation() {
+//  if (!isUsedField("neighbors")) {
+//    return;
+//  }
+//
+//  for(map<int, PdbAtomInfoContainer>::iterator currentInfo = additionalAtomData.begin();
+//    currentInfo != additionalAtomData.end(); currentInfo++
+//  ) {
+//    for(vector<int>::iterator neighbor = currentInfo->second.neighbors.begin();
+//      neighbor != currentInfo->second.neighbors.end(); neighbor++
+//    ) {
+//      World::getInstance().getAtom(AtomById(currentInfo->first))
+//          ->addBond(World::getInstance().getAtom(AtomById(atomIdMap[*neighbor])));
+//    }
+//  }
+}
+
+/**
+ * Replaces atom IDs read from the file by the corresponding world IDs. All IDs
+ * IDs of the input string will be replaced; expected separating characters are
+ * "-" and ",".
+ *
+ * \param string in which atom IDs should be adapted
+ *
+ * \return input string with modified atom IDs
+ */
+string PdbParser::adaptIdDependentDataString(string data) {
+//  // there might be no IDs
+//  if (data == "-") {
+//    return "-";
+//  }
+//
+//  char separator;
+//  int id;
+//  stringstream line, result;
+//  line << data;
+//
+//  line >> id;
+//  result << atomIdMap[id];
+//  while (line.good()) {
+//    line >> separator >> id;
+//    result << separator << atomIdMap[id];
+//  }
+//
+//  return result.str();
+  return "";
+}
+
+
+PdbAtomInfoContainer::PdbAtomInfoContainer() :
+  name("-"),
+  resName("-"),
+  chainID("0"),
+  resSeq("0"),
+  occupancy("0"),
+  tempFactor("0"),
+  segID("0"),
+  charge("0")
+{}
+
+void PdbAtomInfoContainer::set(PdbKey::PdbDataKey key, string value) {
+  switch (key) {
+    case PdbKey::extType :
+      extType = value;
+      break;
+    case PdbKey::name :
+      name = value;
+      break;
+    case PdbKey::resName :
+      resName = value;
+      break;
+    case PdbKey::chainID :
+      chainID = value;
+      break;
+    case PdbKey::resSeq :
+      resSeq = value;
+      break;
+    case PdbKey::occupancy :
+      occupancy = value;
+      break;
+    case PdbKey::tempFactor :
+      tempFactor = value;
+      break;
+    case PdbKey::segID :
+      segID = value;
+      break;
+    case PdbKey::charge :
+      charge = value;
+      break;
+    default :
+      cout << "Unknown key: " << key << ", value: " << value << endl;
+      break;
+  }
+}
+
+string PdbAtomInfoContainer::get(PdbKey::PdbDataKey key) {
+  switch (key) {
+    case PdbKey::extType :
+      return extType;
+    case PdbKey::name :
+      return name;
+    case PdbKey::resName :
+      return resName;
+    case PdbKey::chainID :
+      return chainID;
+    case PdbKey::resSeq :
+      return resSeq;
+    case PdbKey::occupancy :
+      return occupancy;
+    case PdbKey::tempFactor :
+      return tempFactor;
+    case PdbKey::segID :
+      return segID;
+    case PdbKey::charge :
+      return charge;
+    default :
+      cout << "Unknown key: " << key << endl;
+      return "";
+  }
+}
+
